package com.fanruan.agent.jdbc;

import com.fanruan.agent.jdbc.resultset.AgentResultSet;
import com.fanruan.annotation.BindClass;

import java.sql.Array;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Map;

/**
 * @author Yichen Dai
 * @date 2022/8/31 16:52
 */
@BindClass
public class AgentArray implements Array {
    Array array;

    public AgentArray(Array array){
        this.array = array;
    }

    @Override
    public String getBaseTypeName() throws SQLException {
        return array.getBaseTypeName();
    }

    @Override
    public int getBaseType() throws SQLException {
        return array.getBaseType();
    }

    @Override
    public Object getArray() throws SQLException {
        return array.getArray();
    }

    @Override
    public Object getArray(Map<String, Class<?>> map) throws SQLException {
        return array.getArray(map);
    }

    @Override
    public Object getArray(long index, int count) throws SQLException {
        return array.getArray(index, count);
    }

    @Override
    public Object getArray(long index, int count, Map<String, Class<?>> map) throws SQLException {
        return array.getArray(index, count, map);
    }

    @Override
    public ResultSet getResultSet() throws SQLException {
        return new AgentResultSet(array.getResultSet());
    }

    @Override
    public ResultSet getResultSet(Map<String, Class<?>> map) throws SQLException {
        return new AgentResultSet(array.getResultSet(map));
    }

    @Override
    public ResultSet getResultSet(long index, int count) throws SQLException {
        return new AgentResultSet(array.getResultSet(index, count));
    }

    @Override
    public ResultSet getResultSet(long index, int count, Map<String, Class<?>> map) throws SQLException {
        return new AgentResultSet(array.getResultSet(index, count, map));
    }

    @Override
    public void free() throws SQLException {
        array.free();
    }
}
