package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.sql.Clob;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/8/29 20:34
 */
@BindClass
public class AgentClob implements Clob {
    private Clob clob;

    public AgentClob(Clob clob){
        this.clob = clob;
    }

    @Override
    public long length() throws SQLException {
        return clob.length();
    }

    @Override
    public String getSubString(long pos, int length) throws SQLException {
        return clob.getSubString(pos, length);
    }

    @Override
    public Reader getCharacterStream() throws SQLException {
        return new AgentReader(clob.getCharacterStream());
    }

    @Override
    public InputStream getAsciiStream() throws SQLException {
        return new AgentInputStream(clob.getAsciiStream());
    }

    @Override
    public long position(String searchstr, long start) throws SQLException {
        return clob.position(searchstr, start);
    }

    @Override
    public long position(Clob searchstr, long start) throws SQLException {
        return clob.position(searchstr, start);
    }

    @Override
    public int setString(long pos, String str) throws SQLException {
        return clob.setString(pos, str);
    }

    @Override
    public int setString(long pos, String str, int offset, int len) throws SQLException {
        return clob.setString(pos, str, offset, len);
    }

    @Override
    public OutputStream setAsciiStream(long pos) throws SQLException {
        return new AgentOutputStream(clob.setAsciiStream(pos));
    }

    @Override
    public Writer setCharacterStream(long pos) throws SQLException {
        return new AgentWriter(clob.setCharacterStream(pos));
    }

    @Override
    public void truncate(long len) throws SQLException {
        clob.truncate(len);
    }

    @Override
    public void free() throws SQLException {
        clob.free();
    }

    @Override
    public Reader getCharacterStream(long pos, long length) throws SQLException {
        return new AgentReader(clob.getCharacterStream(pos, length));
    }
}
