package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.io.IOException;
import java.io.InputStream;

/**
 * @author Yichen Dai
 * @date 2022/9/8 18:15
 */
@BindClass
public class AgentInputStream extends InputStream {
    private InputStream inputStream;

    public AgentInputStream(InputStream inputStream){
        this.inputStream = inputStream;
    }

    @Override
    public int read() throws IOException {
        return inputStream.read();
    }

    @Override
    public int read(byte b[]) throws IOException {
        return inputStream.read(b);
    }

    @Override
    public int read(byte b[], int off, int len) throws IOException {
        return inputStream.read(b, off, len);
    }

    @Override
    public long skip(long n) throws IOException {
        return inputStream.skip(n);
    }

    @Override
    public int available() throws IOException {
        return inputStream.available();
    }

    @Override
    public void close() throws IOException {
        inputStream.close();
    }

    @Override
    public synchronized void mark(int readlimit) {
        inputStream.mark(readlimit);
    }

    @Override
    public synchronized void reset() throws IOException {
        inputStream.reset();
    }

    @Override
    public boolean markSupported() {
        return inputStream.markSupported();
    }
}
