package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.sql.Clob;
import java.sql.NClob;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/9/9 10:49
 */
@BindClass
public class AgentNClob implements NClob {
    private NClob nClob;

    public AgentNClob(NClob nClob){
        this.nClob = nClob;
    }

    @Override
    public long length() throws SQLException {
        return nClob.length();
    }

    @Override
    public String getSubString(long pos, int length) throws SQLException {
        return nClob.getSubString(pos, length);
    }

    @Override
    public Reader getCharacterStream() throws SQLException {
        return new AgentReader(nClob.getCharacterStream());
    }

    @Override
    public InputStream getAsciiStream() throws SQLException {
        return new AgentInputStream(nClob.getAsciiStream());
    }

    @Override
    public long position(String searchstr, long start) throws SQLException {
        return nClob.position(searchstr, start);
    }

    @Override
    public long position(Clob searchstr, long start) throws SQLException {
        return nClob.position(searchstr, start);
    }

    @Override
    public int setString(long pos, String str) throws SQLException {
        return nClob.setString(pos, str);
    }

    @Override
    public int setString(long pos, String str, int offset, int len) throws SQLException {
        return nClob.setString(pos, str, offset, len);
    }

    @Override
    public OutputStream setAsciiStream(long pos) throws SQLException {
        return new AgentOutputStream(nClob.setAsciiStream(pos));
    }

    @Override
    public Writer setCharacterStream(long pos) throws SQLException {
        return new AgentWriter(nClob.setCharacterStream(pos));
    }

    @Override
    public void truncate(long len) throws SQLException {
        nClob.truncate(len);
    }

    @Override
    public void free() throws SQLException {
        nClob.free();
    }

    @Override
    public Reader getCharacterStream(long pos, long length) throws SQLException {
        return new AgentReader(nClob.getCharacterStream(pos, length));
    }
}
