package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.io.IOException;
import java.io.OutputStream;

/**
 * @author Yichen Dai
 * @date 2022/9/9 10:49
 */
@BindClass
public class AgentOutputStream extends OutputStream {
    private OutputStream outputStream;

    public AgentOutputStream(OutputStream outputStream){
        this.outputStream = outputStream;
    }

    @Override
    public void write(int b) throws IOException {
        this.outputStream.write(b);
    }

    @Override
    public void write(byte b[]) throws IOException {
        outputStream.write(b);
    }

    @Override
    public void write(byte b[], int off, int len) throws IOException {
        outputStream.write(b, off, len);
    }

    @Override
    public void flush() throws IOException {
        outputStream.flush();
    }

    @Override
    public void close() throws IOException {
        outputStream.close();
    }
}
