package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.sql.ParameterMetaData;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/8/25 16:41
 */

@BindClass
public class AgentParameterMetaData implements ParameterMetaData {
    private ParameterMetaData metaData;

    public AgentParameterMetaData(ParameterMetaData metaData){
        this.metaData = metaData;
    }

    @Override
    public int getParameterCount() throws SQLException {
        return metaData.getParameterCount();
    }

    @Override
    public int isNullable(int param) throws SQLException {
        return metaData.isNullable(param);
    }

    @Override
    public boolean isSigned(int param) throws SQLException {
        return metaData.isSigned(param);
    }

    @Override
    public int getPrecision(int param) throws SQLException {
        return metaData.getPrecision(param);
    }

    @Override
    public int getScale(int param) throws SQLException {
        return metaData.getScale(param);
    }

    @Override
    public int getParameterType(int param) throws SQLException {
        return metaData.getParameterType(param);
    }

    @Override
    public String getParameterTypeName(int param) throws SQLException {
        return metaData.getParameterTypeName(param);
    }

    @Override
    public String getParameterClassName(int param) throws SQLException {
        return metaData.getParameterClassName(param);
    }

    @Override
    public int getParameterMode(int param) throws SQLException {
        return metaData.getParameterMode(param);
    }

    @Override
    public <T> T unwrap(Class<T> iface) throws SQLException {
        return metaData.unwrap(iface);
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        return metaData.isWrapperFor(iface);
    }
}
