package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;
import io.socket.client.IO;

import java.io.IOException;
import java.io.Reader;

/**
 * @author Yichen Dai
 * @date 2022/9/8 16:55
 */
@BindClass
public class AgentReader extends Reader {

    Reader reader;

    public AgentReader(Reader reader){
        this.reader = reader;
    }

    @Override
    public int read(java.nio.CharBuffer target) throws IOException {
        return reader.read(target);
    }

    @Override
    public int read() throws IOException{
        return reader.read();
    }

    @Override
    public int read(char cbuf[]) throws IOException {
        return reader.read(cbuf);
    }

    @Override
    public long skip(long n) throws IOException {
        return reader.skip(n);
    }

    @Override
    public boolean ready() throws IOException{
        return reader.ready();
    }

    @Override
    public int read(char[] cbuf, int off, int len) throws IOException {
        return reader.read(cbuf, off, len);
    }

    @Override
    public boolean markSupported() {
        return reader.markSupported();
    }

    @Override
    public void mark(int readAheadLimit) throws IOException {
        reader.mark(readAheadLimit);
    }

    @Override
    public void reset() throws IOException {
        reader.reset();
    }

    @Override
    public void close() throws IOException {
        reader.close();
    }
}
