package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/9/1 14:45
 */
@BindClass
public class AgentResultSetMetaData implements ResultSetMetaData {
    private ResultSetMetaData metaData;

    public AgentResultSetMetaData(ResultSetMetaData metaData){
        this.metaData = metaData;
    }

    @Override
    public int getColumnCount() throws SQLException {
        return metaData.getColumnCount();
    }

    @Override
    public boolean isAutoIncrement(int column) throws SQLException {
        return metaData.isAutoIncrement(column);
    }

    @Override
    public boolean isCaseSensitive(int column) throws SQLException {
        return metaData.isCaseSensitive(column);
    }

    @Override
    public boolean isSearchable(int column) throws SQLException {
        return metaData.isSearchable(column);
    }

    @Override
    public boolean isCurrency(int column) throws SQLException {
        return metaData.isCurrency(column);
    }

    @Override
    public int isNullable(int column) throws SQLException {
        return metaData.isNullable(column);
    }

    @Override
    public boolean isSigned(int column) throws SQLException {
        return metaData.isSigned(column);
    }

    @Override
    public int getColumnDisplaySize(int column) throws SQLException {
        return metaData.getColumnDisplaySize(column);
    }

    @Override
    public String getColumnLabel(int column) throws SQLException {
        return metaData.getColumnLabel(column);
    }

    @Override
    public String getColumnName(int column) throws SQLException {
        return metaData.getColumnName(column);
    }

    @Override
    public String getSchemaName(int column) throws SQLException {
        return metaData.getSchemaName(column);
    }

    @Override
    public int getPrecision(int column) throws SQLException {
        return metaData.getPrecision(column);
    }

    @Override
    public int getScale(int column) throws SQLException {
        return metaData.getScale(column);
    }

    @Override
    public String getTableName(int column) throws SQLException {
        return metaData.getTableName(column);
    }

    @Override
    public String getCatalogName(int column) throws SQLException {
        return metaData.getCatalogName(column);
    }

    @Override
    public int getColumnType(int column) throws SQLException {
        return metaData.getColumnType(column);
    }

    @Override
    public String getColumnTypeName(int column) throws SQLException {
        return metaData.getColumnTypeName(column);
    }

    @Override
    public boolean isReadOnly(int column) throws SQLException {
        return metaData.isReadOnly(column);
    }

    @Override
    public boolean isWritable(int column) throws SQLException {
        return metaData.isWritable(column);
    }

    @Override
    public boolean isDefinitelyWritable(int column) throws SQLException {
        return metaData.isDefinitelyWritable(column);
    }

    @Override
    public String getColumnClassName(int column) throws SQLException {
        return metaData.getColumnClassName(column);
    }

    @Override
    public <T> T unwrap(Class<T> iface) throws SQLException {
        return metaData.unwrap(iface);
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        return metaData.isWrapperFor(iface);
    }
}
