package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.io.IOException;
import java.io.Writer;

/**
 * @author Yichen Dai
 * @date 2022/9/9 10:48
 */
@BindClass
public class AgentWriter extends Writer {
    private Writer writer;

    public AgentWriter(Writer writer){
        this.writer = writer;
    }

    @Override
    public void write(int c) throws IOException {
        writer.write(c);
    }

    @Override
    public void write(char cbuf[]) throws IOException {
        writer.write(cbuf);
    }

    @Override
    public void write(char[] cbuf, int off, int len) throws IOException {
        writer.write(cbuf, off, len);
    }

    @Override
    public void write(String str) throws IOException {
        writer.write(str);
    }

    @Override
    public void write(String str, int off, int len) throws IOException {
        writer.write(str, off, len);
    }

    /**
     * chain calling return this instead of new Agent Class
     * @throws IOException
     */
    @Override
    public Writer append(CharSequence csq) throws IOException {
        writer.append(csq);
        return this;
    }

    @Override
    public Writer append(CharSequence csq, int start, int end) throws IOException {
        writer.append(csq, start, end);
        return this;
    }

    @Override
    public Writer append(char c) throws IOException {
        writer.append(c);
        return this;
    }

    @Override
    public void flush() throws IOException {
        writer.flush();
    }

    @Override
    public void close() throws IOException {
        writer.close();
    }
}
