package com.fanruan.agent.jdbc.driver;

import com.fanruan.agent.jdbc.connection.AgentConnection;
import com.fanruan.annotation.BindClass;

import java.sql.*;
import java.util.Enumeration;
import java.util.Properties;
import java.util.logging.Logger;

/**
 * @author Yichen Dai
 */
@BindClass
public class AgentDriver implements Driver {

    static{
        try {
            DriverManager.registerDriver(new AgentDriver());
        } catch (Exception e) {
            throw new RuntimeException("Can't register driver");
        }
    }

    @Override
    public Connection connect(String url, Properties info) throws SQLException {
        return new AgentConnection(DriverManager.getConnection(url, info));
    }

    @Override
    public boolean acceptsURL(String url) throws SQLException {
        return true;
    }

    @Override
    public DriverPropertyInfo[] getPropertyInfo(String url, Properties info){
        return new DriverPropertyInfo[0];
    }

    @Override
    public int getMajorVersion() {
        return 0;
    }

    @Override
    public int getMinorVersion() {
        return 0;
    }

    @Override
    public boolean jdbcCompliant() {
        return false;
    }

    @Override
    public Logger getParentLogger(){
        return null;
    }
}


