package com.fanruan;

/**
 * @author Yichen Dai
 * @date 2022/8/23 15:49
 */

import com.fanruan.cache.ClientCache;
import com.fanruan.proxy.ProxyFactory;
import com.fanruan.service.jdbc.driver.ServiceDriver;
import com.fanruan.utils.DBProperties;

import java.sql.*;
import java.util.Properties;

/** Base test class with common constants, data structures and methods */
public class AbstractDriverTest {
    static final Properties info = new Properties();

    static final String[][] dbNameAndDriver = new String[][]{
            DBProperties.HSQL
    };

    static final ServerStater server = new ServerStater(dbNameAndDriver);
    static final AgentStarter agent =  new AgentStarter(dbNameAndDriver);


    static {
        info.setProperty("user", "sa");
        info.setProperty("password", "");
        info.setProperty("agentID", "1001");
        info.setProperty("agentDBName", DBProperties.HSQL[0]);
    }

    static void openSocket(){
        while(ClientCache.getClient(
                info.getProperty("agentID"),
                info.getProperty("agentDBName"))
                == null){
        }
    }

    void shutDownAgent(){
        agent.shutDown();
    }

    /**
     * Gets a connection
     * @return Connection a database connection
     * @throws SQLException raised if any error occurs
     */
    public static Connection getConnection() throws SQLException {
        Driver driver = (ServiceDriver) ProxyFactory.getProxy(ServiceDriver.class, null);
        Connection conn = driver.connect("jdbc:hsqldb:mem:test;sql.syntax_mys=true", info);
        return conn;
    }
}
