package com.fanruan;

import com.fanruan.agent.jdbc.driver.AgentDriver;
import com.fanruan.service.jdbc.driver.ServiceDriver;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;

import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.SQLFeatureNotSupportedException;
import java.util.Enumeration;

/**
 * @author Yichen Dai
 * @date 2022/9/9 16:44
 */
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
public class DriverTest{

    @Test
    public void test() throws SQLException, ClassNotFoundException {
        Class.forName("com.fanruan.service.jdbc.driver.ServiceDriver");
        Enumeration<Driver> registeredDrivers = DriverManager.getDrivers();
        while (registeredDrivers.hasMoreElements()) {
            Driver driver = registeredDrivers.nextElement();
            if(driver instanceof ServiceDriver){
                Assertions.assertEquals(0, driver.getPropertyInfo("jdbc:hsqldb:mem:test;sql.syntax_mys=true", null).length);
                Assertions.assertEquals(ServiceDriver.DRIVER_VERSION_MAJOR, driver.getMajorVersion());
                Assertions.assertEquals(ServiceDriver.DRIVER_VERSION_MINOR, driver.getMinorVersion());
                Assertions.assertFalse(driver.jdbcCompliant());
                Assertions.assertThrows(SQLFeatureNotSupportedException.class, () -> driver.getParentLogger());
            }
        }

    }
}
