package com.fanruan;

import com.fanruan.pojo.message.RpcRequest;
import com.fanruan.proxy.interceptor.InterceptorUtils;
import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;

import java.lang.reflect.Method;
import java.util.Map;
import java.util.Properties;

/**
 * @author Yichen Dai
 * @date 2022/8/29 11:11
 */
public class InterceptorIT implements MethodInterceptor {
    Class<?> clazz;
    Map<String, RpcRequest> map;


    InterceptorIT(Class<?> clazz, Map<String, RpcRequest> map){
        this.clazz = clazz;
        this.map = map;
    }

    @Override
    public Object intercept(Object o, Method method, Object[] objects, MethodProxy methodProxy) throws Throwable {
        if(InterceptorUtils.isNotImplemented(method)
                || InterceptorUtils.isLocalMethod(method)){
            return methodProxy.invokeSuper(o, objects);
        }

        RpcRequest request = InterceptorUtils.generateRequest(clazz, o, method, objects);
        map.put(null, request);

        return methodProxy.invokeSuper(o, objects);
    }
}
